<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="事件" prop="eventId">
        <el-select v-model="queryParams.eventId" placeholder="请选择事件" style="width: 100%">
          <el-option
            v-for="item in eventInfoList"
            :key="item.responseId"
            :label="item.title"
            :value="item.responseId"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="时间" prop="createTimeRange">
        <el-date-picker
          v-model="createTimeRange"
          type="datetimerange"
          value-format="yyyy-MM-dd HH:mm"
          @change="timeChange"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
     <!-- <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <!--<el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="infoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="事件" align="center" prop="eventTitle" />
      <el-table-column label="组号" align="center" prop="groupId" :formatter="groupFormat" />
      <el-table-column label="联系人" align="center" prop="disposer" :show-overflow-tooltip="true"/>
      <el-table-column label="应急预案" align="center" prop="planTitle" :show-overflow-tooltip="true"/>
      <el-table-column label="创建时间" align="center" prop="createTime"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-message"
            @click="handleNotify(scope.row)"
          >通知</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleNotifyList(scope.row)"
          >通知结果</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改应急报警对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="事件" prop="eventId">
          <el-select v-model="form.eventId" placeholder="请选择事件" style="width: 100%">
            <el-option
              v-for="item in eventInfoList"
              :key="item.responseId"
              :label="item.title"
              :value="item.responseId"
            />
          </el-select>
        </el-form-item>

        <el-form-item label="组号" prop="groupId">
          <el-select
            v-model="form.groupId"
            placeholder="请选择组号"
            size="small"
            style="width: 100%"
          >
            <el-option
              v-for="item in groups"
              :key="item.dictValue"
              :label="item.dictLabel"
              :value="item.dictValue"
            />
          </el-select>
        </el-form-item>

        <!--<el-form-item label="联系人" prop="disposerId">
          <el-select v-model="form.disposerId" multiple placeholder="请选择联系人" style="width: 100%">
            <el-option
              v-for="item in contactsList"
              :key="item.id"
              :label="item.username"
              :value="item.id"
            />
          </el-select>
        </el-form-item>-->

        <el-form-item label="应急预案" prop="planId">
          <el-select v-model="form.planId" multiple placeholder="请选择应急预案" style="width: 100%">
            <el-option
              v-for="item in planList"
              :key="item.id"
              :label="item.title"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <DetailInfo ref="detail"/>
    <!-- 通知结果 -->
    <NotifyList ref="notifyList"/>

  </div>
</template>

<script>
import { listInfo, getInfo, delInfo, addInfo, updateInfo, exportInfo } from "@/api/emergency/alarm";
import { emergencyResponseList } from "@/api/emergency/response";
import { urgentContactsList } from "@/api/urgent/contacts";
import { planList } from "@/api/urgent/plan";
import DetailInfo from "./components/DetailInfo";
import { alarmNotify } from "@/api/emergency/notifyRecord";
import NotifyList from "./components/NotifyList";
export default {
  name: "Info",
  components: {
    DetailInfo,
    NotifyList
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 应急报警表格数据
      infoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        eventId: null,
        createBeginTime: null,
        createEndTime: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        eventId:[
          { required: true, message: "请选择事件", trigger: "change" },
        ],
        groupId:[
          { required: true, message: "请选择组号", trigger: "change" },
        ],
        /*disposerId:[
          { required: true, message: "请选择联系人", trigger: "change" },
        ],*/
        planId:[
          { required: true, message: "请选择应急预案", trigger: "change" },
        ]
      },
      eventInfoList: [],
      contactsList: [],
      planList: [],
      createTimeRange: [],
      groups: []
    };
  },
  created() {
    this.getList();
    this.getEmergencyResponseList();
    //this.getUrgentContactsList();
    this.getPlanList();
    this.getDicts("t_urgent_contacts_group").then(res =>{
        this.groups = res.data;
    })
  },
  methods: {
    /** 查询应急报警列表 */
    getList() {
      this.loading = true;
      listInfo(this.queryParams).then(response => {
        this.infoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    //事件
    getEmergencyResponseList(){
      emergencyResponseList().then(res => {
        if(res.code == 200){
            this.eventInfoList = res.data;
        }
      })
    },
    getUrgentContactsList(){
      urgentContactsList().then(res =>{
        if(res.code == 200){
            this.contactsList = res.data;
        }
      })
    },
    getPlanList(){
      planList().then(res =>{
        if(res.code == 200){
            this.planList = res.data;
        }
      })
    },
    groupFormat(row, column) {
      return this.selectDictLabel(this.groups, row.groupId);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        eventId: null,
        disposerId: null,
        planId: null,
        createTime: null,
        createBy: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTimeRange = [];
      this.queryParams.createBeginTime = null;
      this.queryParams.createEndTime = null;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加应急报警";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getInfo(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改应急报警";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateInfo(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInfo(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除应急报警编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delInfo(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有应急报警数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportInfo(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    handleDetail(row){
      this.$refs.detail.getAlarmInfo(row.id);
    },
    timeChange(val){
      this.queryParams.createBeginTime = val[0];
      this.queryParams.createEndTime = val[1];
    },
    //通知
    handleNotify(row){
      const ids = row.id || this.ids;
      this.$confirm('是否确认通知应急报警编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return alarmNotify({alarmId:row.id});
      }).then(() => {
        this.getList();
        this.msgSuccess("通知成功");
      }).catch(() => {});
    },
    //通知结果
    handleNotifyList(row){
      this.$refs.notifyList.getNotifyList(row.id);
    }

  }
};
</script>
